Subject: Re: [PATCH] powerpc/configs: Enable function trace by default

From: Balbir Singh <[email-masked]>
Date: Wed, 19 Apr 2017 22:50:04 +1000

On Wed, 2017-04-19 at 21:13 +1000, Anton Blanchard wrote:
> Hi Balbir,
> 
> > > FTRACE is quite CPU consumming, shouldn't it really be on by
> > > default ?  
> > 
> > It does some work at boot to NOP out function entry points at _mcount
> > locations. Is that what you are referring to? Or the overhead of the
> > code in terms of size? Most distro kernels have tracing on by default.
> > 
> > The rest of the overhead is enablement based.
> 
> Unfortunately the overhead is somewhat high without
> CONFIG_MPROFILE_KERNEL, and enabling that option will break old
> toolchains. It would be great if we could automatically enable it based
> on the toolchain.
> 
> Even with CONFIG_MPROFILE_KERNEL enabled, we aren't noping out the
> redundant mflr at the start of each function.
>

Very good catch! I sent the enablement assuming that we want to have these
enabled to ensure we generally have these enabled in the distro kernels
and ideally want to test with these enabled and many of us turn them
on in any case. Do you see an issue with this being enabled by default?
I presume most workloads run on kernels that have them enabled these days?

CONFIG_MPROFILE_KERNEL depends on CC_USING_MPROFILE_KERNEL which is
automatically detected and is LE only.

Balbir Singh